package com.qmth.sop.business.bean.result;

import com.fasterxml.jackson.annotation.JsonInclude;
import com.qmth.sop.common.enums.FlowApproveOperationEnum;
import com.qmth.sop.common.enums.InOutTypeEnum;
import io.swagger.annotations.ApiModelProperty;

import java.io.Serializable;
import java.util.Objects;

/**
 * @Description: 异常已审核result
 * @Param:
 * @return:
 * @Author: wangliang
 * @Date: 2023/8/10
 */
@JsonInclude(JsonInclude.Include.NON_NULL)
public class DingApplyDoneResult extends WorkTaskResult implements Serializable {

    @ApiModelProperty(value = "异常审核类型")
    InOutTypeEnum dingExceptionType;

    @ApiModelProperty(value = "异常审核类型str")
    String dingExceptionTypeStr;

    @ApiModelProperty(value = "异常日期")
    Long exceptionTime;

    @ApiModelProperty(value = "补卡时间")
    Long applyTime;

    @ApiModelProperty(value = "理由")
    String reason;

    @ApiModelProperty(value = "附件/截图")
    String attachmentPaths;

    @ApiModelProperty(value = "申请时间")
    Long createTime;

    @ApiModelProperty(value = "审核结果")
    FlowApproveOperationEnum approveOperation;

    @ApiModelProperty(value = "审核结果Str")
    String approveOperationStr;

    @ApiModelProperty(value = "审核人")
    String approveUsersName;

    public Long getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Long createTime) {
        this.createTime = createTime;
    }

    public InOutTypeEnum getDingExceptionType() {
        return dingExceptionType;
    }

    public void setDingExceptionType(InOutTypeEnum dingExceptionType) {
        this.dingExceptionType = dingExceptionType;
    }

    public String getDingExceptionTypeStr() {
        if (Objects.nonNull(dingExceptionType)) {
            return dingExceptionType.getTitle();
        } else {
            return dingExceptionTypeStr;
        }
    }

    public void setDingExceptionTypeStr(String dingExceptionTypeStr) {
        this.dingExceptionTypeStr = dingExceptionTypeStr;
    }

    public Long getExceptionTime() {
        return exceptionTime;
    }

    public void setExceptionTime(Long exceptionTime) {
        this.exceptionTime = exceptionTime;
    }

    public Long getApplyTime() {
        return applyTime;
    }

    public void setApplyTime(Long applyTime) {
        this.applyTime = applyTime;
    }

    public String getReason() {
        return reason;
    }

    public void setReason(String reason) {
        this.reason = reason;
    }

    public String getAttachmentPaths() {
        return attachmentPaths;
    }

    public void setAttachmentPaths(String attachmentPaths) {
        this.attachmentPaths = attachmentPaths;
    }

    public FlowApproveOperationEnum getApproveOperation() {
        return approveOperation;
    }

    public void setApproveOperation(FlowApproveOperationEnum approveOperation) {
        this.approveOperation = approveOperation;
    }

    public String getApproveOperationStr() {
        if (Objects.nonNull(approveOperation)) {
            return approveOperation.getTitle();
        } else {
            return approveOperationStr;
        }
    }

    public void setApproveOperationStr(String approveOperationStr) {
        this.approveOperationStr = approveOperationStr;
    }

    public String getApproveUsersName() {
        return approveUsersName;
    }

    public void setApproveUsersName(String approveUsersName) {
        this.approveUsersName = approveUsersName;
    }
}
